#ifndef __OOL_XPOINT_H__
#define __OOL_XPOINT_H__

/*===========================================================================*/
/* OOL ------------------- the Open Object Library ------------- OS/2 Beta 1 */
/*===========================================================================*/
/*                              class: XPoint                                */
/*                       derived from: XObject                               */
/*                        last update: 3/97                                  */
/*                      programmed by: Stefan von Brauk (sbrauk@gwdg.de)     */
/*===========================================================================*/


#include "xobject.h"


class _export_ XPoint: public XObject
{
      friend class XBox;
      friend class XText;
      friend class XCircle;
      friend class XArc;
      friend class XLine;
      friend class XMarker;
   protected:
      LONG x, y;
   public:
      XPoint( const long xPoint = 0, const long yPoint = 0)
				{ x = xPoint; y = yPoint;}
      XPoint( const XPoint * pp) { x=pp->x; y=pp->y; }
      virtual ~XPoint() {;}
      long GetX( void ) const { return x; }
      long GetY( void ) const { return y; }
      void Set( const LONG x_1, const LONG y_1) { x=x_1; y=y_1; }
      void SetX( const long newX ) {x = newX; }
      void SetY( const long newY ) {y = newY; }
      XPoint operator =(const XPoint& p) { x=p.x; y=p.y; return *this; }
};

#endif
