#ifndef __OOL_XRESLIB_H__
#define __OOL_XRESLIB_H__

/*===========================================================================*/
/* OOL ------------------- the Open Object Library ------------- OS/2 Beta 1 */
/*===========================================================================*/
/*                              class: XResourceLibrary                      */
/*                       derived from: XObject                               */
/*                        last update: 12/96                                 */
/*                      programmed by: Stefan von Brauk (sbrauk@gwdg.de)     */
/*===========================================================================*/



#include "xobject.h"


class XProcess;
class XWindow;
class XString;

class _export_ XResourceLibrary: public XObject
{
   private:
      HMODULE moduleHandle;
      XProcess * proc;
   public:
      XResourceLibrary( const XProcess *, const char * path = NULL);
      ~XResourceLibrary();
      ULONG GetModuleHandle( void ) const { return moduleHandle; }
      BOOL LoadString( XString * string, const unsigned long resId);
      OOL_WINDOWHANDLE LoadMenu( const XWindow * f, const unsigned long id);
      XProcess * GetProcess(void) const { return proc; }
};


#endif
